CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Proof of Concept for PinDefs                                         PinDefs_Demo_002.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PRI Version

  result := String( "PinDefs_Demo_002" )

CON
  _CLKMODE = pindefs#_CLKMODE
  _XINFREQ = pindefs#_XINFREQ

OBJ

  ' Select one of the following or change to match your own hardware
  
' pindefs : "PinDefs_ProtoBoard"                                            
' pindefs : "PinDefs_DemoBoard"                                             
  pindefs : "PinDefs_AiChip_ProtoBoard_Original"                                    
  
  tv      : "TV_Text"

VAR
  long tvPin
  long ledPin
  
PUB Main | i

  pindefs.SetPins
  
  tvPin  := pindefs.GetPinNumber( MyPinName(String( "TV_PIN"  )) )                      
  ledPin := pindefs.GetPinNumber( MyPinName(String( "LED_PIN" )) )                    

  if tvPin => 0
    tv.Start( tvPin )
    tv.Str( Version )
    tv.Out( " " )

    i := String("TV_PIN")
    tv.Str( i )
    tv.Out( " " )
    i := pindefs.GetPinTypeIdFromTypeIdName(MyPinName(i))
    tv.Hex( i, 8 )
    tv.Out( " " )
    tv.Str( pindefs.GetPinTypeIdNameFromTypeId(i) )
    tv.Out( $0D )
     
    repeat i from 0 to 10
      ShowPinName( 1,  i    )
      ShowPinName( 13, i+11 )
      ShowPinName( 26, i+22 )
      tv.Out( $0D )

  if ledPin => 0
    DIRA[ ledPin ] := 1
    repeat
      ! OUTA[ ledPin ]
      WaitCnt( CLKFREQ / 1000 * 250 + CNT )

PRI ShowPinName( column, pinNumber )
  if pinNumber =< 31
    tv.Out( $0A )
    tv.Out( column-1 )
    tv.Dec( pinNumber )
    if pinNumber < 10
      tv.Out( " " )
    tv.Out( " " )
    tv.Str( pindefs.GetPinName(pinNumber) )


PRI MyPinName( strPtr )

  ' This converts the pin names I want to use into pin names which the Propeller Community has chosen
  ' as standard. Do not add any extra parameters or local variables because the call to pindefs.Alias()
  ' relies on a specific stack configuration when called. If wanting to remove the pindefs.Alias() calls
  ' either remove this PinName() methos and use only stadard names, or delete all pindefs.Alias() calls
  ' and replace with a "result := strPtr" or "return strPtr".
  
  pindefs.Alias( String("TV_PIN")  , String("TV_ADC1") )
  pindefs.Alias( String("LED_PIN") , String("LED_1")   )
